//+------------------------------------------------------------------+
//|                                statistical-report-operations.mqh |
//|                                                           andrea |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "andrea"

#include <Trade\PositionInfo.mqh>
CPositionInfo positionInfo;
class Report{

   private:

      string fileName;
      int potentialPipsGain;
      int realPipsGained;
      double orderPriceOpen;
      double orderPriceClose;
   
   public:
   
      void updateMaxPipsPotentialGain(double orderPriceClose, string typeOfOperation){         
         
         int actualPips;
         double normalized; //normalized double number
         double r; //rounded number

         if( typeOfOperation == "BUY" ){
            normalized = NormalizeDouble( (orderPriceClose - orderPriceOpen), Digits() );
            actualPips = round(normalized * MathPow( 10, Digits() ) );
         }else if ( typeOfOperation == "SELL" ){
            normalized = NormalizeDouble( (orderPriceOpen - orderPriceClose), Digits() );
            actualPips = round(normalized * MathPow( 10, Digits() ) );
         }
         
         //printf("actualPips=" + actualPips);
         
         if(potentialPipsGain < actualPips ){     
            potentialPipsGain = actualPips;  
            //printf("potentialGain=" + potentialPipsGain);          
         }
         
      }
      
      void writeReport(string typeOfOperation){
         // open file
         fileName = "statistical-report-operation.csv";
         int delimiter = StringGetCharacter(";", 0);
         int fileHandler = FileOpen(fileName, FILE_READ | FILE_WRITE | FILE_TXT | FILE_ANSI, delimiter);
         if( fileHandler != INVALID_HANDLE ){
         FileSeek(fileHandler, 0, SEEK_END);
            FileWrite(fileHandler, Symbol(), typeOfOperation, potentialPipsGain, realPipsGained);
            //printf("potentialPipsGain=" + potentialPipsGain + " realPipsGained=" + realPipsGained);
            FileClose(fileHandler);
         }else
            printf("Error: cant' open file");
      }
      
      void setPotentialPipsGainToZero(){
         potentialPipsGain = 0;
      }
   
   void setPipsGained(){
   
      double difference;
      int pipsGained;
         
      for(int i=PositionsTotal()-1;i>=0;i--){ // returns the number of current position
         if(positionInfo.SelectByIndex(i)){     // selects the position by index for further access to its properties
            if(positionInfo.Symbol()==Symbol()){                         
               //if(OrderGetInteger(ORDER_TYPE) == ORDER_TYPE_BUY){               
               if(positionInfo.PositionType() == POSITION_TYPE_BUY){               
                  difference = orderPriceClose - orderPriceOpen;
                  pipsGained = round(difference * MathPow(10, Digits()) );
                  /*
                  printf("orderPriceOpen=" + orderPriceOpen + 
                     " orderPriceClose=" + orderPriceClose + 
                     " difference=" + NormalizeDouble(difference, Digits()) +   
                     " pipsGained=" + pipsGained );
                  */
                  break;
               }else if(positionInfo.PositionType() == POSITION_TYPE_SELL){               
               //if(OrderGetInteger(ORDER_TYPE) == ORDER_TYPE_SELL){               
                  difference = orderPriceOpen - orderPriceClose;
                  pipsGained = round(difference * MathPow(10, Digits()) );
                  /*
                  printf("orderPriceOpen=" + orderPriceOpen + 
                        " orderPriceClose=" + orderPriceClose +
                        " difference=" + NormalizeDouble(difference, Digits()) +   
                        " pipsGained=" + pipsGained ) ;
                  */
                  break;
               }
            }
         }
      }
      
      realPipsGained = pipsGained;
      
   }

   void setOrderPriceOpen(string typeOperation){
      
      if( typeOperation == "BUY" )
         orderPriceOpen = SymbolInfoDouble(Symbol(),SYMBOL_ASK);
      else if ( typeOperation == "SELL" )
         orderPriceOpen = SymbolInfoDouble(Symbol(),SYMBOL_BID);
      
   }
   
   void setOrderPriceClose(string typeOfOperation){
      
      if( typeOfOperation == "BUY" )
         orderPriceClose = SymbolInfoDouble( Symbol(), SYMBOL_ASK );
      else if( typeOfOperation == "SELL" )
         orderPriceClose = SymbolInfoDouble( Symbol(), SYMBOL_BID ); 

   }

};